Index: /pjproject/branches/projects/aps-direct/build.symbian/pjmedia_audiodev.mmp
===================================================================
--- /pjproject/branches/projects/aps-direct/build.symbian/pjmedia_audiodev.mmp	(revision 2499)
+++ /pjproject/branches/projects/aps-direct/build.symbian/pjmedia_audiodev.mmp	(revision 2500)
@@ -7,5 +7,5 @@
 // GCCE optimization setting
 //
-OPTION		GCCE -O2 -fno-unit-at-a-time
+//OPTION		GCCE -O2 -fno-unit-at-a-time
 
 MACRO		PJ_M_I386=1
Index: /pjproject/branches/projects/aps-direct/build.symbian/symbian_ua.mmp
===================================================================
--- /pjproject/branches/projects/aps-direct/build.symbian/symbian_ua.mmp	(revision 2499)
+++ /pjproject/branches/projects/aps-direct/build.symbian/symbian_ua.mmp	(revision 2500)
@@ -11,7 +11,4 @@
 MACRO			PJ_M_I386=1
 MACRO			PJ_SYMBIAN=1
-
-OPTION			GCCE -O2 -fno-unit-at-a-time
-SRCDBG
 
 // Source files
Index: /pjproject/branches/projects/aps-direct/build.symbian/symbian_ua.pkg
===================================================================
--- /pjproject/branches/projects/aps-direct/build.symbian/symbian_ua.pkg	(revision 2500)
+++ /pjproject/branches/projects/aps-direct/build.symbian/symbian_ua.pkg	(revision 2500)
@@ -0,0 +1,18 @@
+; symbian_ua.pkg
+
+; Languages
+&EN
+
+; Header
+#{"symbian_ua"},(0x200235D3), 0, 1, 1
+
+; Platform compatibility
+[0x101F7961], *, *, *,{"Series60ProductID"}
+
+; vendor
+%{"PJSIP"}
+:"PJSIP"
+
+; Target
+"$(EPOCROOT)Epoc32\release\$(PLATFORM)\$(TARGET)\symbian_ua.exe"-"!:\sys\bin\symbian_ua.exe"
+"$(EPOCROOT)Epoc32\data\z\private\10003a3f\apps\symbian_ua_reg.rSC"-"!:\private\10003a3f\import\apps\symbian_ua_reg.rSC"
Index: /pjproject/branches/projects/aps-direct/build.symbian/symbian_ua_udeb.pkg
===================================================================
--- /pjproject/branches/projects/aps-direct/build.symbian/symbian_ua_udeb.pkg	(revision 2499)
+++ /pjproject/branches/projects/aps-direct/build.symbian/symbian_ua_udeb.pkg	(revision 2500)
@@ -1,3 +1,6 @@
-; symbian_ua.pkg
+; symbian_ua_udeb.pkg
+
+; for Carbide development, please use symbian_ua.pkg for comfortness
+; (epoc32 path, platform, and target are set automatically using env vars)
 
 ; Languages
@@ -5,5 +8,5 @@
 
 ; Header
-#{"symbian_ua"},(0xA000000D), 0, 1, 1
+#{"symbian_ua"},(0x200235D3), 0, 1, 1
 
 ; Platform compatibility
Index: /pjproject/branches/projects/aps-direct/build.symbian/symbian_ua_urel.pkg
===================================================================
--- /pjproject/branches/projects/aps-direct/build.symbian/symbian_ua_urel.pkg	(revision 2499)
+++ /pjproject/branches/projects/aps-direct/build.symbian/symbian_ua_urel.pkg	(revision 2500)
@@ -1,3 +1,6 @@
 ; symbian_ua.pkg
+
+; for Carbide development, please use symbian_ua.pkg for comfortness
+; (epoc32 path, platform, and target are set automatically using env vars)
 
 ; Languages
@@ -5,5 +8,5 @@
 
 ; Header
-#{"symbian_ua"},(0xA000000D), 0, 1, 1
+#{"symbian_ua"},(0x200235D3), 0, 1, 1
 
 ; Platform compatibility
Index: /pjproject/branches/projects/aps-direct/pjsip-apps/src/symbian_ua/ua.cpp
===================================================================
--- /pjproject/branches/projects/aps-direct/pjsip-apps/src/symbian_ua/ua.cpp	(revision 2499)
+++ /pjproject/branches/projects/aps-direct/pjsip-apps/src/symbian_ua/ua.cpp	(revision 2500)
@@ -498,4 +498,5 @@
    	    "  j    Toggle loopback audio\n"
 #endif
+   	    "up/dn  Increase/decrease output volume\n"
 	    "  s    Subscribe " SIP_DST_URI "\n"
 	    "  S    Unsubscribe presence\n"
@@ -532,4 +533,30 @@
 static void HandleMainMenu(TKeyCode kc) {
     switch (kc) {
+    
+    case EKeyUpArrow:
+    case EKeyDownArrow:
+	{
+	    unsigned vol;
+	    pj_status_t status;
+	    
+	    status = pjsua_snd_get_setting(
+			     PJMEDIA_AUD_DEV_CAP_OUTPUT_VOLUME_SETTING, &vol);
+	    if (status == PJ_SUCCESS) {
+		if (kc == EKeyUpArrow)
+		    vol = PJ_MIN(100, vol+10);
+		else
+		    vol = (vol>=10 ? vol-10 : 0);
+		status = pjsua_snd_set_setting(
+				    PJMEDIA_AUD_DEV_CAP_OUTPUT_VOLUME_SETTING,
+				    &vol, PJ_TRUE);
+	    }
+
+	    if (status == PJ_SUCCESS) {
+		PJ_LOG(3,(THIS_FILE, "Output volume set to %d", vol));
+	    } else {
+		pjsua_perror(THIS_FILE, "Error setting volume", status);
+	    }
+	}
+	break;
     
     case 't':