Index: pjproject/branches/1.0/pjmedia/src/test/mips_test.c
===================================================================
--- pjproject/branches/1.0/pjmedia/src/test/mips_test.c	(revision 2547)
+++ pjproject/branches/1.0/pjmedia/src/test/mips_test.c	(revision 2548)
@@ -882,4 +882,5 @@
 }
 
+#if defined(PJMEDIA_HAS_L16_CODEC) && PJMEDIA_HAS_L16_CODEC!=0
 static pj_status_t init_l16_default(pjmedia_endpt *endpt)
 {
@@ -914,4 +915,5 @@
 			       samples_per_frame, flags, te);
 }
+#endif
 
 /***************************************************************************/
@@ -2280,6 +2282,8 @@
 	{ "codec encode/decode - Speex 8Khz", OP_PUT, K8, &speex8_encode_decode},
 	{ "codec encode/decode - Speex 16Khz", OP_PUT, K16, &speex16_encode_decode},
+#if defined(PJMEDIA_HAS_L16_CODEC) && PJMEDIA_HAS_L16_CODEC!=0
 	{ "codec encode/decode - L16/8000/1", OP_PUT, K8, &l16_8_encode_decode},
 	{ "codec encode/decode - L16/16000/1", OP_PUT, K16, &l16_16_encode_decode},
+#endif
 	{ "stream TX/RX - G.711", OP_PUT_GET, K8, &create_stream_pcmu},
 	{ "stream TX/RX - G.711 SRTP 32bit", OP_PUT_GET, K8, &create_stream_pcmu_srtp32_no_auth},
Index: pjproject/branches/1.0/pjmedia/src/test/sdp_neg_test.c
===================================================================
--- pjproject/branches/1.0/pjmedia/src/test/sdp_neg_test.c	(revision 2547)
+++ pjproject/branches/1.0/pjmedia/src/test/sdp_neg_test.c	(revision 2548)
@@ -1329,5 +1329,5 @@
     pj_status_t status;
 
-    status = pjmedia_sdp_parse(pool, oa->sdp1, pj_native_strlen(oa->sdp1),
+    status = pjmedia_sdp_parse(pool, oa->sdp1, pj_ansi_strlen(oa->sdp1),
 				&sdp1);
     if (status != PJ_SUCCESS) {
@@ -1371,5 +1371,5 @@
 
 	/* Parse and validate remote answer */
-	status = pjmedia_sdp_parse(pool, oa->sdp2, pj_native_strlen(oa->sdp2),
+	status = pjmedia_sdp_parse(pool, oa->sdp2, pj_ansi_strlen(oa->sdp2),
 				   &sdp2);
 	if (status != PJ_SUCCESS) {
@@ -1406,5 +1406,5 @@
 
 	/* Parse and validate the correct active media. */
-	status = pjmedia_sdp_parse(pool, oa->sdp3, pj_native_strlen(oa->sdp3),
+	status = pjmedia_sdp_parse(pool, oa->sdp3, pj_ansi_strlen(oa->sdp3),
 				   &sdp3);
 	if (status != PJ_SUCCESS) {
@@ -1448,5 +1448,5 @@
 	if (oa->sdp2) {
 	    /* Parse and validate initial local capability */
-	    status = pjmedia_sdp_parse(pool, oa->sdp2, pj_native_strlen(oa->sdp2),
+	    status = pjmedia_sdp_parse(pool, oa->sdp2, pj_ansi_strlen(oa->sdp2),
 				       &sdp2);
 	    if (status != PJ_SUCCESS) {
@@ -1508,5 +1508,5 @@
 
 	/* Parse the correct answer. */
-	status = pjmedia_sdp_parse(pool, oa->sdp3, pj_native_strlen(oa->sdp3),
+	status = pjmedia_sdp_parse(pool, oa->sdp3, pj_ansi_strlen(oa->sdp3),
 				   &sdp3);
 	if (status != PJ_SUCCESS) {
Index: pjproject/branches/1.0/tests/pjsua/inc_sip.py
===================================================================
--- pjproject/branches/1.0/tests/pjsua/inc_sip.py	(revision 2547)
+++ pjproject/branches/1.0/tests/pjsua/inc_sip.py	(revision 2548)
@@ -92,9 +92,5 @@
 			print str(time.strftime("%H:%M:%S ")) + txt
 
-	def create_req(self, method, sdp, branch="", extra_headers=""):
-		if branch=="":
-			self.cseq = self.cseq + 1
-		msg = req_templ
-		msg = msg.replace("$METHOD", method)
+	def update_fields(self, msg):
 		if self.tcp:
 			transport_param = ";transport=tcp"
@@ -104,12 +100,21 @@
 		msg = msg.replace("$LOCAL_IP", self.local_ip)
 		msg = msg.replace("$LOCAL_PORT", str(self.local_port))
-		if branch=="":
-			branch=str(random.random())
-		msg = msg.replace("$BRANCH", branch)
 		msg = msg.replace("$FROM_TAG", self.local_tag)
 		msg = msg.replace("$TO_TAG", self.rem_tag)
 		msg = msg.replace("$CALL_ID", self.call_id)
 		msg = msg.replace("$CSEQ", str(self.cseq))
+		branch=str(random.random())
+		msg = msg.replace("$BRANCH", branch)
+		return msg
+
+	def create_req(self, method, sdp, branch="", extra_headers=""):
+		if branch=="":
+			self.cseq = self.cseq + 1
+		msg = req_templ
+		msg = msg.replace("$METHOD", method)
 		msg = msg.replace("$SIP_HEADERS", extra_headers)
+		if branch=="":
+			branch=str(random.random())
+		msg = msg.replace("$BRANCH", branch)
 		if sdp!="":
 			msg = msg.replace("$CONTENT_LENGTH", str(len(sdp)))
@@ -119,5 +124,5 @@
 		msg = msg + "\r\n"
 		msg = msg + sdp
-		return msg
+		return self.update_fields(msg)
 
 	def create_response(self, request, code, reason, to_tag=""):
Index: pjproject/branches/1.0/tests/pjsua/mod_sendto.py
===================================================================
--- pjproject/branches/1.0/tests/pjsua/mod_sendto.py	(revision 2547)
+++ pjproject/branches/1.0/tests/pjsua/mod_sendto.py	(revision 2548)
@@ -20,5 +20,5 @@
 	
 	if len(cfg.complete_msg) != 0:
-		req = cfg.complete_msg
+		req = dlg.update_fields(cfg.complete_msg)
 	else:
 		req = dlg.create_invite(cfg.sdp, cfg.extra_headers)